/// <reference types="node" />
/// <reference types="node" />
import type { Readable } from 'stream';
import type { BinaryData } from './types';
import type { INodeExecutionData, IBinaryData } from 'n8n-workflow';
export declare class BinaryDataService {
    private mode;
    private managers;
    init(config: BinaryData.Config): Promise<void>;
    copyBinaryFile(workflowId: string, executionId: string, binaryData: IBinaryData, filePath: string): Promise<IBinaryData>;
    store(workflowId: string, executionId: string, bufferOrStream: Buffer | Readable, binaryData: IBinaryData): Promise<IBinaryData>;
    toBuffer(bufferOrStream: Buffer | Readable): Promise<Buffer>;
    getAsStream(binaryDataId: string, chunkSize?: number): Promise<Readable>;
    getAsBuffer(binaryData: IBinaryData): Promise<Buffer>;
    getPath(binaryDataId: string): string;
    getMetadata(binaryDataId: string): Promise<BinaryData.Metadata>;
    deleteMany(ids: BinaryData.IdsForDeletion): Promise<void>;
    duplicateBinaryData(workflowId: string, executionId: string, inputData: Array<INodeExecutionData[] | null>): Promise<INodeExecutionData[][]>;
    rename(oldFileId: string, newFileId: string): Promise<void>;
    private createBinaryDataId;
    private duplicateBinaryDataInExecData;
    private getManager;
}
